const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {

    @property({type: cc.Label})
    label: cc.Label[] = [];

    @property
    maxWidth: number = 1440;

    public FitCallEvents: any = [];

    onLoad() {
        window["FitHandle"] = this;
        // cc.Camera.main.backgroundColor = new cc.Color(255, 255, 255, 255);
        let firstFire: any = null;
        let self = this;
        window.onresize = function () {
            if (firstFire === null) {
                // console.log("进入适配")
                firstFire = setTimeout(function () {
                    firstFire = null;
                    self.FitCanvas(self);
                }, 100);
            }
        }
    }

    FitCanvas(self: any) {
        // console.log("winSize大小：" + cc.winSize.width.toString() + " " + cc.winSize.height.toString());
        // console.log(cc.Camera.main.node.width.toString())
        // cc.log(document.body.clientWidth);
        // cc.winSize.width = document.body.clientWidth;
        if (self.node.width !== cc.winSize.width) {
            if (cc.winSize.width <= self.maxWidth) {
                this.node.width = cc.winSize.width;
                // cc.Camera.main.node.width = cc.winSize.width;
            } else {
                this.node.width = self.maxWidth;
            }
            this.node.x = this.node.width * 0.5;
            this.getComponent(cc.Widget).updateAlignment();
        }
        self.label[0].string = cc.winSize.width.toString();
        self.label[1].string = self.node.width.toString();
        self.FitCallEvents.forEach((item, index, arr: any) => {
            item(self.node.width, self.node.height);
        });
    }

    onEnable() {
        this.FitCanvas(this);
    }

    start() {

    }

    // update (dt) {}
}
