"use strict";
cc._RF.push(module, '13848/FSPRBlY++DSwgP66M', 'CanvasFit');
// code/Fit/CanvasFit.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var NewClass = /** @class */ (function (_super) {
    __extends(NewClass, _super);
    function NewClass() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.label = [];
        _this.maxWidth = 1440;
        _this.FitCallEvents = [];
        return _this;
        // update (dt) {}
    }
    NewClass.prototype.onLoad = function () {
        window["FitHandle"] = this;
        // cc.Camera.main.backgroundColor = new cc.Color(255, 255, 255, 255);
        var firstFire = null;
        var self = this;
        window.onresize = function () {
            if (firstFire === null) {
                // console.log("进入适配")
                firstFire = setTimeout(function () {
                    firstFire = null;
                    self.FitCanvas(self);
                }, 100);
            }
        };
    };
    NewClass.prototype.FitCanvas = function (self) {
        // console.log("winSize大小：" + cc.winSize.width.toString() + " " + cc.winSize.height.toString());
        // console.log(cc.Camera.main.node.width.toString())
        // cc.log(document.body.clientWidth);
        // cc.winSize.width = document.body.clientWidth;
        if (self.node.width !== cc.winSize.width) {
            if (cc.winSize.width <= self.maxWidth) {
                this.node.width = cc.winSize.width;
                // cc.Camera.main.node.width = cc.winSize.width;
            }
            else {
                this.node.width = self.maxWidth;
            }
            this.node.x = this.node.width * 0.5;
            this.getComponent(cc.Widget).updateAlignment();
        }
        self.label[0].string = cc.winSize.width.toString();
        self.label[1].string = self.node.width.toString();
        self.FitCallEvents.forEach(function (item, index, arr) {
            item(self.node.width, self.node.height);
        });
    };
    NewClass.prototype.onEnable = function () {
        this.FitCanvas(this);
    };
    NewClass.prototype.start = function () {
    };
    __decorate([
        property({ type: cc.Label })
    ], NewClass.prototype, "label", void 0);
    __decorate([
        property
    ], NewClass.prototype, "maxWidth", void 0);
    NewClass = __decorate([
        ccclass
    ], NewClass);
    return NewClass;
}(cc.Component));
exports.default = NewClass;

cc._RF.pop();